#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <ComCtrls.hpp>
#include <Forms.hpp>
#include "LibMySql.hpp"
#include <stdio.h>

#define SHOW_FIELDNAME  0
#define SHOW_TYPE  1
#define SHOW_NULL  2
#define SHOW_DEFAULT  4
#define SHOW_EXTRA  5
#define QUOTE_CHAR	'`'


/* index into 'show fields from table' */

#define SHOW_FIELDNAME  0
#define SHOW_TYPE  1
#define SHOW_NULL  2
#define SHOW_DEFAULT  4
#define SHOW_EXTRA  5
#define QUOTE_CHAR	'`'

#define NOT_NULL_FLAG	1		/* Field can't be NULL */
#define PRI_KEY_FLAG	2		/* Field is part of a primary key */
#define UNIQUE_KEY_FLAG 4		/* Field is part of a unique key */
#define MULTIPLE_KEY_FLAG 8		/* Field is part of a key */
#define BLOB_FLAG	16		/* Field is a blob */
#define UNSIGNED_FLAG	32		/* Field is unsigned */
#define ZEROFILL_FLAG	64		/* Field is zerofill */
#define BINARY_FLAG	128
/* The following are only sent to new clients */
#define ENUM_FLAG	256		/* field is an enum */
#define AUTO_INCREMENT_FLAG 512		/* field is a autoincrement field */
#define TIMESTAMP_FLAG	1024		/* Field is a timestamp */
#define SET_FLAG	2048		/* field is a set */
#define NUM_FLAG	32768		/* Field is num (for clients) */
#define PART_KEY_FLAG	16384		/* Intern; Part of some key */
#define GROUP_FLAG	32768		/* Intern: Group field */
#define UNIQUE_FLAG	65536		/* Intern: Used by sql_yacc */

#define IS_PRI_KEY(n)	((n) & PRI_KEY_FLAG)
#define IS_NOT_NULL(n)	((n) & NOT_NULL_FLAG)
#define IS_BLOB(n)	((n) & BLOB_FLAG)
#define IS_NUM(t)	((t) <= FIELD_TYPE_INT24 || (t) == FIELD_TYPE_YEAR)
#define IS_NUM_FIELD(f)	 ((f)->flags & NUM_FLAG)
#define INTERNAL_NUM_FIELD(f) (((f)->type <= FIELD_TYPE_INT24 && ((f)->type != FIELD_TYPE_TIMESTAMP || (f)->length == 14 || (f)->length == 8)) || (f)->type == FIELD_TYPE_YEAR)


/* Exit codes */

#define EX_USAGE 1
#define EX_MYSQLERR 2
#define EX_CONSCHECK 3
#define EX_EOM 4


	/* General constants */
#define SC_MAXWIDTH	256	/* Max width of screen (for error messages) */
#define FN_LEN		256	/* Max file name len */
#define FN_HEADLEN	253	/* Max length of filepart of file name */
#define FN_EXTLEN	20	/* Max length of extension (part of FN_LEN) */
#define FN_REFLEN	512	/* Max length of full path-name */
#define FN_EXTCHAR	'.'
#define FN_HOMELIB	'~'	/* ~/ is used as abbrev for home dir */
#define FN_CURLIB	'.'	/* ./ is used as abbrev for current dir */
#define FN_PARENTDIR	".."	/* Parentdirectory; Must be a string */
#define FN_DEVCHAR	':'
#define  INT_MAX  65536L

#define DMPVERSION	"DATATEC-V1.0"

typedef unsigned long my_ulonglong;
typedef unsigned int  uint;
typedef unsigned long	ulong;
typedef char 	*my_string; /* String of characters */

typedef struct st_dynamic_string {
  char *str;
  unsigned int length,max_length,alloc_increment;
} DYNAMIC_STRING;


typedef struct st_options
 {
  uint opt_keywords,tFlag,opt_drop,Write_heder, opt_where,
    opt_create_db,opt_databases,opt_quoted,cFlag,extended_insert,quick,opt_lock;
  char * WhereStr; // where-SQL-String
 } DmpOpt;


class TMyDumpObj
{
 private:
  int len, opt_mysql_port;
  my_string opt_mysql_unix_port;
  char  insert_pat[12*1024];
  void write_heder(FILE *sql_file, char *db_name);
  char *quote_name(char *name, char *buff);
  char *strend( const char *s);
  char *strmov(char *dst, const char *src);
  int test_if_special_chars(const char *str);
  int unescape(FILE *file,char *pos,int length);
  void safe_exit(int error);
 public:
  MYSQL  *My_Sock;
  MYSQL_RES  *SQLRes;
  PMYSQL_ROW  PMyRow;
  DmpOpt DpO; //DumpOptions
  char *current_host;
  uint TbRecords;
  TProgressBar *MyProgress;
  uint ProgrStep;

  TMyDumpObj()
  {
    DpO.opt_keywords=0;
    DpO.tFlag=0;
    DpO.opt_drop=1;
    DpO.opt_quoted=0;
    DpO.cFlag=1;
    DpO.opt_where=0;
    DpO.opt_lock=0;
    DpO.extended_insert=1;
    DpO.opt_databases=0;
    DpO.opt_create_db=0;
    DpO.Write_heder=1;
    DpO.WhereStr=NULL;
    TbRecords = 0L;
    ProgrStep=100;
  };

  char * DmpVersion(void) { return DMPVERSION; };
  int init_dumping(FILE *sql_file,char *database);
  void  dumpTable(int numFields, char *table, FILE  *sql_file);
  int getTableStructure(MYSQL *sock,char *table, char* db, FILE  *sql_file);
};



